#include "ofApp.h"
//#include "RAlimentar.h"


//--------------------------------------------------------------
void ofApp::setup(){
    ofEnableDepthTest();
    //    ofSetVerticalSync(true);
    
    
    ofSetLogLevel(OF_LOG_SILENT);  //VERBOSE);
    ofBackground(10, 10, 20); //20, 20, 35);
    
    ofDisableArbTex(); // we need GL_TEXTURE_2D for our models coords.
    
    
    //    ofLoadImage(chaoTexture, "mapaEvora_chaoShadow_octa.inv.png");
    ofLoadImage(foto1, "foto1.png");
    ofLoadImage(foto2, "foto2.png");
    ofLoadImage(foto3, "foto3.jpg");
    ofLoadImage(foto4, "foto4.jpg");
    
    
    float size = 380;
    points[0].x = size; points[0].y = 0;
    points[1].x = 0; points[2].y = 0;
    points[2].x = 0; points[2].y = size;
    points[3].x = size; points[3].y = size;
    
    
    
    // this sets the camera's distance from the object
    //    cam.setAutoDistance(true);
    
    //    cam.enableMouseInput();
    cam.disableMouseInput();
    
    
    //    cam.setDrag(0.001); // set speed mouse cam movement
    
    model.loadModel("mapaEvora_3D_extruded_big_inv.dae", false);
    chao.loadModel("mapaEvora_3D_extruded_big_octa_inv.dae", false);
    
    
    
    //    model.setScale(1, 1, 1); // (1.2, 1.2, -1.2) negativo corrige inversao coord Z
    
    /*
    model.setLoopStateForAllAnimations(OF_LOOP_NORMAL);
    model.playAllAnimations();
    if(!bAnimate) {
        model.setPausedForAllAnimations(true);
    } */
    
    //  ___________________  LIGHT ________________
    
    light1.setup();
    light2.setup();
    
    ofEnableDepthTest();
    //    ofEnableLighting();
    
    //    materialPlane.setShininess(10);
    //  light1.setAreaLight(1300,1300);
    
    // Directional Lights emmit light based on their orientation, regardless of their position //
    // light.setDiffuseColor(ofColor(0.f, 0.f, 255.f));
    //    light1.setSpecularColor(ofColor(255.f, 255.f, 255.f));
    
    light1.setSpotlight();
    //    light1.setPointLight();
    //    light1.setDirectional();
    //    light1.setOrientation( ofVec3f(0, 0, 90));
    light1.setPosition(0, 500, 0);
    light1.rotate(-90, 1, 0, 0);
    
    
    g_onoff_nome = false;
    g_onoff_cmr = false;
    
    //v4.set( 0, 15, 0, 0 ); //  v4.x, v4.y, z, w
    //vetor.set( 10, 10, 12, 20);
    vetor.set(g_cartXa, g_cartYa, g_cartXb, g_cartYb);
    
    //  ____________________________ classe Grupos
/*    grp.setup(strg_grupo,
              strg_ramo,
              strg_loc,
              strg_prop,
              strg_ativ,
              g_cartXa, g_cartYa, g_cartXb, g_cartYb);
*/
    
    //__________________________________ classe Comercio
    //cmr.setup(vetor.x, vetor.y);
    cmr.setup(strg_nome, strg_loc, g_cartXa, g_cartYa, g_cartXb, g_cartYb);
    
    
    
    // ___________________________________ leitura data _______________________
    
    //Use a ofTrueTypeFont for scalable text
    //    font.load("frabk.ttf", 122);
    
    string filePath = "database2.csv";
    ofFile file(filePath);
    
    if(!file.exists()){
        ofLogError("The file " + filePath + " is missing");
    }
    
    ofBuffer buffer(file);
    
    //// Read file line by line
    for (ofBuffer::Line linha = buffer.getLines().begin(), end = buffer.getLines().end(); linha != end; ++linha) {
        string line = *linha;
        
       //cout << "line: "<< line << " linha: " << &linha << endl;
        
        //Split line into strings
        vector<string> words = ofSplitString(line, "|");
        
//                for(int i=0; i<words.size(); i++){
//                    // cout << "word : "<< i << " " << words[i] << endl;
//                }
        
//                for(int i=0; i<line.size(); i++){
//                    cout << "line : " << " " << line << endl;
//                }
        
        //Store strings
        if (words.size()>=9) {
            
            // GRUPO | RAMO | LOCALIZACAO | PROPRIEDADE | ATIVIDADE | LAT | LONG
            string strg_grupo  = words[0];  // GRUPO - nome
            string strg_ramo  = words[1];
            string strg_loc = words[2]; // localizacao RAMO
            string strg_prop  = words[3];
            string strg_ativ  = words[4];  // atividade
            
            string strg_latA   = words[5];  // lat A N-S - rua start
            string strg_longA  = words[6]; // long A E-O
            string strg_latB   = words[7];  // lat B N-S - rua end
            string strg_longB  = words[8]; // long B E-O
            
            ++numlinha;
            
            // strings to floats
            float gpsLATa = ofToFloat(strg_latA);
            float gpsLONGa = ofToFloat(strg_longA);
            float gpsLATb = ofToFloat(strg_latB);
            float gpsLONGb = ofToFloat(strg_longB);
            
            
            
            // transfere limites GPS para cartesiano XY do mapa (bool clamp)
            //        area = ofMap(areastrg, 50, 1000, 5, 20, true);
            g_cartXa = ofMap(gpsLONGa, mapGPS_L_LONG, mapGPS_R_LONG, 260, 0, false); // GPS negatv
            g_cartYa = ofMap(gpsLATa, mapGPS_T_LAT, mapGPS_B_LAT, 0, 260, false);
            g_cartXb = ofMap(gpsLONGb, mapGPS_L_LONG, mapGPS_R_LONG, 260, 0, false);
            g_cartYb = ofMap(gpsLATb, mapGPS_T_LAT, mapGPS_B_LAT, 0, 260, false);
            
            
            // _______________________ rotina para povoar GRUPOS (x,y,w,z) ___________________
    //        Grupos grp;
            if (strg_grupo == "Ramo alimentar" && line.empty() == false) {
                
              //  VRamos.push_back(line);
                
            RAlim.setup(strg_grupo,
                       strg_ramo,
                       strg_loc,
                       strg_prop,
                       strg_ativ,
                       g_cartXa, g_cartYa, g_cartXb, g_cartYb);
            
               // VRAlim.push_back(RAlim); // adiciona mais um elemento        !!!!!!!!
            }

            
            
            // _______________________ rotina para povoar classe Comercios (x,y,w,z)
            Comercios cmrcs;
            cmrcs.setup(strg_grupo, strg_loc, g_cartXa, g_cartYa, g_cartXb, g_cartYb);
            if (strg_ativ == "comercio" ) { //&& g_onoff_cmr == true) {
                Vcmrs.push_back(cmrcs); // adiciona mais um elemento
            }
            
            
           /*
            cout << "numlinha: " << numlinha << endl;
            cout << "linha: " << (*linha) << endl;
            cout << "4 GPS strings: "
            << strg_latA << " | "
            << strg_longA << " | "
            << strg_latB << " | "
            << strg_longB << " | " << endl;
            
            cout << "4 GPS carts: "
            << g_cartXa << " | "
            << g_cartYa << " | "
            << g_cartXb << " | "
            << g_cartYb <<endl;
           */
            
            // cout << "4 GPS floats: " << gpsLATa << " | " << gpsLONGa << " | " << gpsLATb << " | " <<   gpsLONGb << " | " << endl;
            //       cout << "g_cartXa= " << g_cartXa << " | g_cartYa= " << g_cartYa << endl;
            //       cout << "g_cartXb= " << g_cartXb << " | g_cartYb= " << g_cartYb << endl;
            
        }
    }
    
    
   
    
    // _______________________________  MENUS ofxUi _______________________
    // ______________________________________________________________ GRUPOS
    
    
    float guiWidth = 350;
    
    
    guiTabBar = new ofxUITabBar();
    
    gui = new ofxUISuperCanvas("GRUPOS");
    
//    gui->addSpacer();
    // gui->addLabel("'1' TO ADD TO LIST", OFX_UI_FONT_SMALL);
    // gui->addLabel("'2' TO DELETE FROM LIST", OFX_UI_FONT_SMALL);
    // gui->addLabel("'3' TO DELETE ALL IN LIST", OFX_UI_FONT_SMALL);
    //gui->addSpacer();
    gui->setWidth(guiWidth);
    
    
    
//    gui->setColorFillHighlight(25);
    //<#ofxUIColor &cb#>, <#ofxUIColor &co#>, <#ofxUIColor &coh#>, <#ofxUIColor &cf#>, <#ofxUIColor &cfh#>, <#ofxUIColor &cp#>, <#ofxUIColor &cpo#>
    
//    ofxUIColor cb = OFX_UI_COLOR_BACK;
//    ofxUIColor co = OFX_UI_COLOR_OUTLINE;
//    ofxUIColor coh = OFX_UI_COLOR_OUTLINE_HIGHLIGHT;
//    ofxUIColor cf = OFX_UI_COLOR_FILL;
//    ofxUIColor cfh = OFX_UI_COLOR_FILL_HIGHLIGHT;
//    ofxUIColor cp = OFX_UI_COLOR_PADDED;
//    ofxUIColor cpo = OFX_UI_COLOR_PADDED_OUTLINE;
    
    gui->setColorPadded(100);
    
    vector<string> names;
    names.push_back("para o lar");
    names.push_back("Grossistas");
    names.push_back("Agropecuaria-cinegetica");
    names.push_back("Alojamento-Restauracao"); // juntar o Lazer?
    names.push_back("Antiguidades");
    names.push_back("Comercio-retalho");
    names.push_back("Comercio-reparacao");

    names.push_back("Comercio");
    
    names.push_back("Combustiveis");
    names.push_back("Construcao-civil");
    names.push_back("Higiene-Beleza");
    names.push_back("Industria-transformadora");
    names.push_back("Lazer"); // ?
    names.push_back("Mobiliarrio");
    names.push_back("Outras-economicas");
    names.push_back("Papelaria-livraria");
    names.push_back("Pequena-Industria");
    names.push_back("Ramo alimentar");
    names.push_back("Saude");
    names.push_back("Transportes-reparacoes");
    names.push_back("Vestuario");

    
    
    gui->setWidgetFontSize(OFX_UI_FONT_SMALL);
//    gui->addToggle("MOSTRAR ATIVOS", true); //SHOW ACTIVE", false);
    
    ddl = gui->addDropDownList("Grupos de Atividade", names); // DYNAMIC DROP DOWN", names);
    ddl->setAllowMultiple(false); // sem escolha multlipla
    ddl->setAutoClose(true);
    gui->autoSizeToFitWidgets();
    gui->setPosition((ofGetWidth()/3)-(guiWidth-20), 10); // ofGetHeight()-150);
    //    gui->setDrawWidgetPadding(true);
    ofAddListener(gui->newGUIEvent, this, &ofApp::guiEvent);

    
    // _______________________________  MENUS ofxUi _______________________
    // ______________________________________________________________ RAMOS
    
    guiTabBar2 = new ofxUITabBar();
    
    gui2 = new ofxUISuperCanvas("RAMOS");
    
    //    gui->addSpacer();
    // gui->addLabel("'1' TO ADD TO LIST", OFX_UI_FONT_SMALL);
    // gui->addLabel("'2' TO DELETE FROM LIST", OFX_UI_FONT_SMALL);
    // gui->addLabel("'3' TO DELETE ALL IN LIST", OFX_UI_FONT_SMALL);
    //gui->addSpacer();
    gui2->setWidth(guiWidth);
    
    vector<string> namesRamos;
    namesRamos.push_back("Pastelaria");  // !!! nomes menu2 tem de vir da string (unicos) da classe
    namesRamos.push_back("Mercearia e similares");
    namesRamos.push_back("Transformação de carnes");

    gui2->setWidgetFontSize(OFX_UI_FONT_SMALL);
    //    gui->addToggle("MOSTRAR ATIVOS", true); //SHOW ACTIVE", false);
    
    ddl2 = gui2->addDropDownList("Ramos de Atividade", namesRamos); // DYNAMIC DROP DOWN", names);
    ddl2->setAllowMultiple(false); // sem escolha multlipla
    ddl2->setAutoClose(true);
    gui2->autoSizeToFitWidgets();
    gui2->setPosition(((ofGetWidth()/3)*2)-(guiWidth-20), 10); // ofGetHeight()-150);
    //    gui->setDrawWidgetPadding(true);
    ofAddListener(gui2->newGUIEvent, this, &ofApp::guiEvent);
    
    

}




//---------------------------------------------------------------------------------
//---------------------------------------------------------------------------------
//---------------------------------------------------------------------------------
void ofApp::update(){
    
    
    
    // mapa movimento de camera
    g_movx = ofMap(ofGetMouseX(), 0, ofGetWidth(), -800, 800);
    float movy = ofMap(ofGetMouseY(), 0, ofGetHeight(), -800, 800);
    
    // para movimento dolly
    if(g_clicAltitude==0){
        g_camDolly = 100;
    } else if(g_clicAltitude==1){
        g_camDolly = 300; // 300
    } else if(g_clicAltitude==2){
        g_camDolly = 800; //800
    }
    
    
    // ___________ MODOS movimento CAMERA ____________________________
    
    g_camraw.set(g_movx, g_camDolly, movy);
    g_camsmooth += (g_camraw - g_camsmooth) * 0.005f; //easing camera pos
    cam.setPosition(g_camsmooth);
    
    if(g_modomovimento==0){
        cam.lookAt(ofPoint(0,0,0));
        
        // este ponto em vez de ser o centro, pode ser a localizacao do comercio que tens
        // seleccionado actualmente, revertendo p o centro caso n tenhas mais nada seleccionado
        
    }  else if(g_modomovimento==1){
        ofPoint farz = g_camsmooth;
        farz.z += -100;
        farz.y = 50;
        
        cam.lookAt(farz);
        
    }    /*else if(g_modomovimento==1){
        ofPoint farz = g_camsmooth;
        farz.z += -100;
        
        cam.lookAt(farz);
    }  */
    
    
    
    //         oscilacao pontos
//    ox = amplitude * cos(TWO_PI * ofGetFrameNum() / period);
//    oy = amplitude * sin(TWO_PI * ofGetFrameNum() / period);
//    oz = amplitude/2 * cos(TWO_PI * ofGetFrameNum() / period*1.2);
    
    //         oscilacao por cordenadas
//    amplX = (vetor.z - vetor.x);
//    amplY = (vetor.w - vetor.y);
//    oscX = amplX * cos(TWO_PI * ofGetFrameNum() / period);
//    oscY = amplY * sin(TWO_PI * ofGetFrameNum() / period);
    
    
    
    // update dos grupos
//    if (strg_grupo == "Ramo alimentar" ) {
//    for (int i = 0; i<Vgrps.size(); i++){
//        Vgrps[i].update(strg_grupo,
//                        strg_ramo,
//                        strg_loc,
//                        strg_prop,
//                        strg_ativ,
//                        
//                        g_onoff_nome, g_onoff_menuRAlim);
//    }
//    }
    
    
  //  string ativ.inser RAlimentar::ramo;
    
    
    // update dos pontos (movimento nas ruas)
    for (int i = 0; i<Vcmrs.size(); i++){
        Vcmrs[i].update(g_onoff_nome, g_onoff_cmr);
    }
    
    
    // ___________  testes para direcao de luz com rato _____________
    //         testa X
    //    light.setOrientation( ofVec3f(ofMap(mouseX, 0, ofGetWidth(), 0, 360), ofMap(mouseY, 0, ofGetHeight(), 0, 360), 0) );
    //         testa Y
    //    light.setOrientation( ofVec3f(220, ofMap(mouseY, 0, ofGetHeight(), 0, 360), 0) );
    //         testa Z
    //    light.setOrientation( ofVec3f(70, 243, ofMap(mouseX, 0, ofGetWidth(), 0, 360)) );
    
    
    //    cout << "mouseX = "<< mouseX << " mouseY = " << mouseY << endl;
    //    cout << "map.mouseX= "<< ofMap(mouseX, 0, ofGetWidth(), 0, 360) << " map.mouseY= " << ofMap(mouseY, 0, ofGetHeight(), 0, 360) << endl;
    
    
    // ___________________ MENUS ofxDatGui ______________
    
    if( g_onoff_menuRAlim == 1) {
        
        // RAlim.update(g_onoff_menuRAlim);
        
        // receber strings da classe menu Ramos
        
        vector<string> v_ramosToMenu;
        
//        v_ramosToMenu = &v_setRamos;
        
     //   v_ramosToMenu.insert(RAlimentar::accessToStrings() );
        
        
    }


}

//---------------------------------------------------------------------------------
//---------------------------------------------------------------------------------
//---------------------------------------------------------------------------------
//---------------------------------------------------------------------------------
void ofApp::draw(){

    ofFill();
    
    // ____________________________ LIGHTS __________________
    
    // (time, beginning, change, duration)
    // ease in circ: -c * (sqrt(1 - (t/=d)*t) - 1) + b;
    // ease out circ: c * sqrt(1 - (t=t/d-1)*t) + b;
    
    
    if(g_switchLight==0) {
        
        g_dimmer1 += 0.0005; // tecto
        g_dimmer2 -= 0.001; // fotos
//        g_dimmer2 = -0.0002 * (sqrt(1 - (1/2)*1) - 1) + 0.4;
        
    } else if(g_switchLight==1) {
        
        g_dimmer1 -= 0.002; // tecto
        g_dimmer2 += 0.0005; // fotos
    }
    
    float dlimit = 0.2;
    if (g_dimmer1 < 0) g_dimmer1 = 0; // minimo de dimmer
    if (g_dimmer1 > dlimit) g_dimmer1 = dlimit;
    if (g_dimmer2 < 0) g_dimmer2 = 0; // minimo de dimmer
    if (g_dimmer2 > dlimit) g_dimmer2 = dlimit; // maximo de dimmer
    
    
    
    light1.enable(); // tecto
    light1.setAttenuation(1, g_dimmer1, 0.0);
    //    light1.setAttenuation(1, atten.x, atten.y);
    
    
    light2.enable(); // chao
    light2.setAreaLight(260, 100); // (width, height)
    light2.setAttenuation(1, 0, g_dimmer2); //0.00215476, g_dimmer2);
    
    
    
    
    // attenuacao luz  (0.1, 0.00215476, atten.y)
    atten.set(ofMap(mouseX, 0, ofGetWidth()-10, 0.003, -0.00), ofMap(mouseY, 0, ofGetHeight()-10, 0.003, -0.00));
    
    //setAttenuation(float constant=1.f, float linear=0.f, float quadratic=0.f)
    //    light2.setAttenuation(0.1, atten.x, atten.y);
    //    light1.setAttenuation(1.0, atten.x, atten.y );
    //    cout << "linear= " << atten.x << " | quadr= " << atten.y << endl;
    //    cout << "mouseX= " << ofGetMouseX() << " | mouseY= " << ofGetMouseY() <<endl;
    
    
    
    //ofEnableBlendMode(OF_BLENDMODE_ALPHA);
    //    ofEnableSeparateSpecularLight();
    
    
#ifndef TARGET_PROGRAMMABLE_GL
    glShadeModel(GL_SMOOTH); //(GL_FLAT); //some model / light stuff
    glEnable(GL_NORMALIZE);
#endif
    
    
    model.enableMaterials();
    //     model.enableNormals();
    chao.enableTextures();
    chao.enableNormals();
    
    
    //    moldura da camera  __________________________________ (desliga legendas???)
    //    cam.begin(ofRectangle(0, 0, ofGetWidth()-200, ofGetHeight()-100));
    cam.begin();
    
    
    foto1.draw(-foto1.getWidth()/2, -50, -800); // velhotes balancas
    ofRotate(90, 0, 1, 0);
    foto2.draw(-foto2.getWidth()/2, -50, -800); // p. giraldo
    ofRotate(90, 0, 1, 0);
    foto3.draw(-foto3.getWidth()/2, -50, -800); // rossio
    ofRotate(90, 0, 1, 0);
    foto4.draw(-foto3.getWidth()/2, -50, -800); // chao covas
    ofRotate(90, 0, 1, 0);
    
    //    materialPlane.begin();
    model.drawFaces();
    //    materialPlane.end();
    chao.setScale(1.4, 1.4, 1.4);
    chao.setPosition(0, 0, -3);
    chao.drawFaces();
    
    
    ofPushMatrix(); // xxxxxxxxxxxxxxxxxxxxxxx
    
    // proporcao para pontos
    ofScale(-g_scale, -g_scale, g_scale);
    ofTranslate(-130, 0, -130);
    ofRotate(90, 1, 0, 0);
    
    
    // ofDrawBox(0, 0, 10, 1, 1, 1);
    // ofDrawBox(130, 130, 10, 1, 1, 1);
    
    
    // imagem da base
    
    
    
    
    
    // _____________ PONTOS _________________________
    
    
    // _____________________desenha Comercios ______________
    //cmr.draw();
    
    if (g_onoff_cmr == true) {
        for (int i = 0; i<Vcmrs.size(); i++){
            //Vcmrs[i].update(g_onoff_cmr);
            Vcmrs[i].draw();
            // cout << "Vcmrs[i]= " << i << endl;

        }
    }
    
    
    ofPopMatrix(); // xxxxxxxxxxxxxxxxxxxxxxx
    
    
    cam.end(); //__________________________________
    
    
    
    // _______________________  MENUS ______________
    
    //    ofDrawRectangle(Linear::easeInOut (time, beginning, change, duration),140,100,300);
    
    
    
    ofDisableDepthTest();
    ofDisableLighting();
    ofDisableSeparateSpecularLight();
    
    ofSetColor(0, 100);
//    ofDrawRectangle( 0, ofGetHeight()-150, ofGetWidth(), 140);
    ofDrawRectangle( 3, 3, ofGetWidth()-3, 60);

    
    
    ofSetColor(100, 100, 60);
    
    ofDrawBitmapString("g_switchLight= " + ofToString(g_switchLight), 3, ofGetHeight()-15);
    ofDrawBitmapString("g_dimmer2= " +  ofToString(g_dimmer2), 3, ofGetHeight()-30);
    ofDrawBitmapString("g_dimmer1= " +  ofToString(g_dimmer1), 3, ofGetHeight()-45);
    
    
    ofDrawBitmapString("fps: " + ofToString(ofGetFrameRate(), 2), ofGetWidth()/2-10, ofGetHeight()-15);
    ofDrawBitmapString("B3B Multimedia | CME.2016", ofGetWidth()-300, ofGetHeight()-15);
    
    // ofDrawBitmapString("atten.x: " + ofToString(atten.x, 6) + " | atten.y= " + ofToString(atten.y, 6), ofGetWidth()/2-80, 15);
    
    
    // estou a testar aqui o retorno do vector :
    
 //   ofDrawBitmapString("Vector ramos: " + RAlimentar::accessToStrings( ?? ), ofGetWidth()/2-10, ofGetHeight()-30);

    

    
    
    // ___________________ MENUS ofxDatGui ______________
    
    if (g_onoff_menuRAlim == 1)
    {
    RAlim.draw();
    }
    
    
    ofEnableDepthTest();
    
}





//----------------------  ofxUi ----------------------------------------
//----------------------------------------------------------------------

void ofApp::guiEvent(ofxUIEventArgs &e)
{
    
    // ________________________________________ MENU 1
    string name = e.widget->getName();

        ofxUIToggle *toggle = (ofxUIToggle *) e.widget;
        ddl->setShowCurrentSelected(toggle->getValue());
    //}
    //else
    if(name == "Grupos de Atividade")
    {
        ofxUIDropDownList *ddlist = (ofxUIDropDownList *) e.widget;
        vector<ofxUIWidget *> &selected = ddlist->getSelected();
        for(int i = 0; i < selected.size(); i++)
        {
            GRPSelected == selected[i]->getName(); // variavel global do GRUPO selecionado.
            
            if (selected[i]->getName() == "Ramo alimentar" )
            {
                //g_onoff_menuRAlim = 1;
                
            } else if (selected[i]->getName() != "Ramo alimentar" )
            {
                //g_onoff_menuRAlim = 0;
            }
            
            // ____________________________________________________________
            if (selected[i]->getName() == "Comercio" )
            {
                //cout << "if SELECTED: " << selected[i]->getName() << endl;
                g_onoff_cmr = 1;
                
            } else if (selected[i]->getName() != "Comercio" )
            {
                g_onoff_cmr = 0;
            }
            
        }
    }
    
    
    
    // ________________________________________ MENU 2
    string name2 = e.widget->getName();
    
    ofxUIToggle *toggle2 = (ofxUIToggle *) e.widget;
    ddl2->setShowCurrentSelected(toggle2->getValue());
    
//    if(..) {
    
//    ddl2->addToggle(ofGetTimestampString()); // adiciona nova entrada

//    }

    if(name2 == "Ramos de Atividade")
    {
        ofxUIDropDownList *ddlist2 = (ofxUIDropDownList *) e.widget;
        vector<ofxUIWidget *> &selected2 = ddlist2->getSelected();
        for(int i = 0; i < selected2.size(); i++)
        {
            RAMSelected == selected2[i]->getName(); // variavel global do GRUPO selecionado.
            
            if (selected2[i]->getName() == "Pastelaria" )
            {
                g_onoff_menuRAlim = 1;
                
            } else if (selected2[i]->getName() != "Pastelaria" )
            {
                g_onoff_menuRAlim = 0;
            }
            
            
        }
    }
    
    
}


//----------------------  ofxUi ----------------------------------------
//--------------------------------------------------------------
void ofApp::exit()
{
    
    delete gui;
    
    /* #1
    for(vector<ofxUICanvas *>::iterator it = guis.begin(); it != guis.end(); ++it)
    {
        ofxUICanvas *g = *it;
        delete g;
    }
    delete guiTabBar;
     */
}






//--------------------------------------------------------------
void ofApp::keyPressed(int key){
    
    /* mesh = model.getMesh(0);
    
    model.setLoopStateForAllAnimations(OF_LOOP_NORMAL);
    model.playAllAnimations();
    if(!bAnimate) {
        model.setPausedForAllAnimations(true);
    } */
    
    
    // __________  ofxUi ____________
    
    /* #1
    
    switch (key)
    {
            
        case 'g':
        {
            guiTabBar->toggleVisible();
        }
            break;
        default:
            break;
    } */
    
    // #2
    
    switch (key) {
        case 'p':
            gui->setDrawWidgetPadding(true);
            break;
        case 'P':
            gui->setDrawWidgetPadding(false);
            break;
            
        case '1':
            ddl->addToggle(ofGetTimestampString()); // adiciona item ao menu
            break;
            
        case '2':
            ddl->removeToggle("ONE");
            break;
            
        case '3':
            ddl->clearToggles();
            break;
            
        case '4':
            ddl->setLabelText("TEST LABEL");
            break;
            
        default:
            break;
    }

}




//--------------------------------------------------------------
void ofApp::keyReleased(int key){
    
    
    if(key=='m'){
        g_modomovimento=(g_modomovimento+1)%2;//0,1,2,0,1,2...
    }
    
    if(key=='l'){
        g_switchLight=(g_switchLight+1)%2;
    }
    
    
    if (key == 'c' && g_onoff_cmr == true) {
        g_onoff_cmr = false;
    } else
        if (key == 'c' && g_onoff_cmr == false) {
            g_onoff_cmr = true;
        }
    
    if (key == 'n' && g_onoff_nome == true) {
        g_onoff_nome = false;
    } else
        if (key == 'n' && g_onoff_nome == false) {
            g_onoff_nome = true;
        }
    
    /*
     // a mesma coisa q em cima
     if(key=='c'){
     g_onoff_cmr = !g_onoff_cmr;
     }
     if(key=='n'){
     g_onoff_nome = !g_onoff_nome;
     }
     */


}

//--------------------------------------------------------------
void ofApp::mouseMoved(int x, int y ){

}

//--------------------------------------------------------------
void ofApp::mouseDragged(int x, int y, int button){

}

//--------------------------------------------------------------
void ofApp::mousePressed(int x, int y, int button){
    
    if (mouseY >= 61) {
    g_clicAltitude=(g_clicAltitude+1)%3; //0,1,2,0,1,2...
    }
}

//--------------------------------------------------------------
void ofApp::mouseReleased(int x, int y, int button){

}

//--------------------------------------------------------------
void ofApp::mouseEntered(int x, int y){

}

//--------------------------------------------------------------
void ofApp::mouseExited(int x, int y){

}

//--------------------------------------------------------------
void ofApp::windowResized(int w, int h){

}

//--------------------------------------------------------------
void ofApp::gotMessage(ofMessage msg){

}

//--------------------------------------------------------------
void ofApp::dragEvent(ofDragInfo dragInfo){ 

}
